import { getAction, deleteAction, putAction, postAction, httpAction } from '@/api/manage'
import Vue from 'vue'
import {UI_CACHE_DB_DICT_DATA } from "@/store/mutation-types"
// 获取当前账号个人信息
export const loginUrlCheck = (params)=>postAction("/sys/loginUrlCheck",params);
// 首页统计
const homeDataStatistics = (params)=>getAction("/community/homepage/dataStatistics",params);
const companyNoticeList = (params)=>getAction("/property-company/notice/companyNotice/list",params);

// 报表统计
const propertyFeeStatistics = (params)=>getAction("/property-community/payment/communityPayment/propertyFeeStatistics",params);
const paymentStatistics = (params)=>getAction("/property-community/payment/communityPayment/paymentStatistics",params);
const repairStatistics = (params)=>getAction("/property-community/property/communityRepair/repairStatistics",params);
const complaintStatistics = (params)=>getAction("/property-community/property/communityComplaint/complaintStatistics",params);

//角色管理
const addRole = (params)=>postAction("/sys/role/add",params);
const editRole = (params)=>putAction("/sys/role/edit",params);
const checkRoleCode = (params)=>getAction("/sys/role/checkRoleCode",params);
const queryall = (params)=>getAction("/sys/role/queryall",params);

//用户管理
const addUser = (params)=>postAction("/sys/user/add",params);
const editUser = (params)=>putAction("/sys/user/edit",params);
const queryUserRole = (params)=>getAction("/sys/user/queryUserRole",params);
const getUserList = (params)=>getAction("/sys/user/list",params);
const frozenBatch = (params)=>putAction("/sys/user/frozenBatch",params);
//验证用户是否存在
const checkOnlyUser = (params)=>getAction("/sys/user/checkOnlyUser",params);
//改变密码
const changePassword = (params)=>putAction("/sys/user/changePassword",params);

//权限管理
const addPermission= (params)=>postAction("/sys/permission/add",params);
const editPermission= (params)=>putAction("/sys/permission/edit",params);
const getPermissionList = (params)=>getAction("/sys/permission/list",params);
const getSystemMenuList = (params)=>getAction("/sys/permission/getSystemMenuList",params);
const getSystemSubmenu = (params)=>getAction("/sys/permission/getSystemSubmenu",params);
const getSystemSubmenuBatch = (params) => getAction('/sys/permission/getSystemSubmenuBatch', params)
const queryTreeList = (params)=>getAction("/sys/permission/queryTreeList",params);
const queryTreeListForRole = (params)=>getAction("/sys/role/queryTreeList",params);
const queryListAsync = (params)=>getAction("/sys/permission/queryListAsync",params);
const queryRolePermission = (params)=>getAction("/sys/permission/queryRolePermission",params);
const saveRolePermission = (params)=>postAction("/sys/permission/saveRolePermission",params);
const queryPermissionsByUser = ()=>getAction("/sys/permission/getUserPermissionByToken");
const loadAllRoleIds = (params)=>getAction("/sys/permission/loadAllRoleIds",params);
const getPermissionRuleList = (params)=>getAction("/sys/permission/getPermRuleListByPermId",params);
const queryPermissionRule = (params)=>getAction("/sys/permission/queryPermissionRule",params);
const queryTreeListByTypeForRole = (params)=>getAction("/sys/role/queryTreeListByType",{...params, platformType: 'committee'});

// 部门管理
const queryDepartTreeList = (params)=>getAction("/sys/sysDepart/queryTreeList",params);
const queryDepartTreeSync = (params)=>getAction("/sys/sysDepart/queryDepartTreeSync",params);
const queryIdTree = (params)=>getAction("/sys/sysDepart/queryIdTree",params);
const queryParentName   = (params)=>getAction("/sys/sysDepart/queryParentName",params);
const searchByKeywords   = (params)=>getAction("/sys/sysDepart/searchBy",params);
const deleteByDepartId   = (params)=>deleteAction("/sys/sysDepart/delete",params);

//二级部门管理
const queryDepartPermission = (params)=>getAction("/sys/permission/queryDepartPermission",params);
const saveDepartPermission = (params)=>postAction("/sys/permission/saveDepartPermission",params);
const queryTreeListForDeptRole = (params)=>getAction("/sys/sysDepartPermission/queryTreeListForDeptRole",params);
const queryDeptRolePermission = (params)=>getAction("/sys/sysDepartPermission/queryDeptRolePermission",params);
const saveDeptRolePermission = (params)=>postAction("/sys/sysDepartPermission/saveDeptRolePermission",params);
const queryMyDepartTreeList = (params)=>getAction("/sys/sysDepart/queryMyDeptTreeList",params);

//日志管理
const deleteLog = (params)=>deleteAction("/sys/log/delete",params);
const deleteLogList = (params)=>deleteAction("/sys/log/deleteBatch",params);

//收费类型列表
const getChargeListApi = (params)=>getAction("/property-company/system/chargeType/chargeTypelist",params);
const addReceiptTemplate = (params)=>postAction("/property-community/system/receiptTemplate/add",params);
// 楼栋列表、单元列表、房间列表
const getBuildingListApi = (params)=>getAction("/property-community/building/communityBuilding/buildingList",params);
const getUnitListApi = (params)=>getAction("/property-community/building/communityBuilding/queryCommunityUnitListByMainId",params);
const getRoomListApi = (params)=>getAction("/property-community/building/communityBuilding/queryCommunityRoomByUnitId",params);

// 业主
const addCommunityOwner = (params)=>postAction("/property-community/info/communityOwner/add",params);
const geCommunityOwnertInfoApi = (params)=>getAction("/property-community/info/communityOwner/queryById",params);
const auditCommunityOwnerApi = (params)=>postAction("/property-community/info/communityOwner/audit",params);
const downloadOwnerTemplate = (params)=>postAction("/property-community/info/communityOwner/downloadOwnerTemplate",params);
const setOwnerLabelApi = (params)=>postAction("/property-community/ownerlabel/ownerLabel/add",params);
const editOwnerLabelApi = (params)=>postAction("/property-community//ownerlabel/ownerLabel/edit",params);
const setCommunityOwnerLabelApi = (params)=>postAction("/property-community/info/communityOwner/setLabel",params);
const geQueryByOwnerIdApi = (params)=>getAction("/property-community/info/communityOwner/queryByOwnerId",params);
const geCommunityDeleteApi = (params)=>getAction("/property-community/ownerlabel/ownerLabel/delete",params);

// 生活缴费-费用规则
const companyPropertyChargerulesApi = (params)=>getAction("/property-company/system/companyChargerule/companyPropertyChargerules",params);
const getTotalMoneyApi = (params)=>getAction("/property-community/payment/communityPayment/getTotalMoney",params);
const geCommunityRuleListApi = (params)=>getAction("/property-company/system/companyChargerule/communityRuleList",params);
const queryByRoomIdApi = (params)=>getAction("/property-community/info/communityOwner/queryByRoomId",params);
const queryLastDegreesByIdApi = (params)=>getAction("/property-community/payment/communityPayment/queryLastDegreesById",params);
const callPayMentApi = (params)=>postAction("/property-community/payment/communityPayment/callPayMent",params);
const queryDetailByIdApi = (params)=>getAction("/property-community/payment/communityPayment/queryById",params);
const getHistoryListdApi = (params)=>getAction("/property-community/payment/communityPayment/historyList",params);

// 报修管理
const queryCommunityRepairApi = (params)=>getAction("/property-community/property/communityRepair/queryById",params);
const auditCommunityRepairApi = (params)=>postAction("/property-community/property/communityRepair/audit",params);
const dispatchCommunityRepairApi = (params)=>postAction("/property-community/property/communityRepair/dispatch",params);

// 投诉管理
const querycommunityComplaintApi = (params)=>getAction("/property-community/property/communityComplaint/queryById",params);
const auditCommunityComplaintApi = (params)=>postAction("/property-community/property/communityComplaint/edit",params);
const auditMoveComplaintApi = (params)=>getAction("/property-community/property/communityComplaint/moveComplaint",params);

// 对账管理
const freezeOrPropertyApi = (params)=>getAction(`/property-central/property/propertySettled/freezeOrThaw/${params.id}/${params.status}`,{});
const getPropertyChargruleListApi = (params)=>getAction("/property-central/property/propertyChargrule/propertyChargruleList",params);
const addCommunityAccountPageApi = (params)=>postAction("/property-community/property/communityReconciliation/add",params);
const getDetailReconciliationApi = (params)=>getAction("/property-community/property/communityReconciliation/queryById",params);
const getAccountListByIdApi = (params)=>getAction("/property-community/property/communityReconciliation/getAccountListById",params);
const communityAuditAccountPageApi = (params)=>postAction("/property-community/property/communityReconciliation/communityAudit",params);
const getCommunityRecordListApi = (params)=>getAction("/property-central/property/auditRecord/getRecordList",params);
const communitySubCompanyApi = (params)=>postAction("/property-community/property/communityReconciliation/communitySubCompany",params);

//数据字典
const addDict = (params)=>postAction("/sys/dict/add",params);
const editDict = (params)=>putAction("/sys/dict/edit",params);
const treeList = (params)=>getAction("/sys/dict/treeList",params);
const addDictItem = (params)=>postAction("/sys/dictItem/add",params);
const editDictItem = (params)=>putAction("/sys/dictItem/edit",params);

//字典标签专用（通过code获取字典数组）
export const ajaxGetDictItems = (code, params)=>getAction(`/sys/dict/getDictItems/${code}`,params);
//从缓存中获取字典配置
function getDictItemsFromCache(dictCode) {
  if (Vue.ls.get(UI_CACHE_DB_DICT_DATA) && Vue.ls.get(UI_CACHE_DB_DICT_DATA)[dictCode]) {
    let dictItems = Vue.ls.get(UI_CACHE_DB_DICT_DATA)[dictCode];
    return dictItems;
  }
}

//系统通告
const doReleaseData = (params)=>getAction("/sys/annountCement/doReleaseData",params);
const doReovkeData = (params)=>getAction("/sys/annountCement/doReovkeData",params);
//获取系统访问量
const getLoginfo = (params)=>getAction("/sys/loginfo",params);
const getVisitInfo = (params)=>getAction("/sys/visitInfo",params);

// 根据部门主键查询用户信息
const queryUserByDepId = (params)=>getAction("/sys/user/queryUserByDepId",params);

// 重复校验
const checkOnlyUserName = (params)=>getAction("/sys/user/checkOnlyUserName",params);  // 用户账号
const duplicateCheck = (params)=>getAction("/sys/duplicate/check",params);
// 加载分类字典
const loadCategoryData = (params)=>getAction("/sys/category/loadAllData",params);
const checkRuleByCode = (params) => getAction('/sys/checkRule/checkByCode', params)
//加载我的通告信息
const getUserNoticeInfo= (params)=>getAction("/sys/sysAnnouncementSend/getMyAnnouncementSend",params);
const getTransitURL = url => `/sys/common/transitRESTful?url=${encodeURIComponent(url)}`
// 中转HTTP请求
export const transitRESTful = {
  get: (url, parameter) => getAction(getTransitURL(url), parameter),
  post: (url, parameter) => postAction(getTransitURL(url), parameter),
  put: (url, parameter) => putAction(getTransitURL(url), parameter),
  http: (url, parameter) => httpAction(getTransitURL(url), parameter),
}

export {
  homeDataStatistics,
  companyNoticeList,
  propertyFeeStatistics,
  paymentStatistics,
  repairStatistics,
  complaintStatistics,
  addRole,
  editRole,
  checkRoleCode,
  addUser,
  editUser,
  queryUserRole,
  getUserList,
  queryall,
  frozenBatch,
  checkOnlyUser,
  changePassword,
  getPermissionList,
  addPermission,
  editPermission,
  queryTreeList,
  queryListAsync,
  queryRolePermission,
  saveRolePermission,
  queryPermissionsByUser,
  loadAllRoleIds,
  getPermissionRuleList,
  queryPermissionRule,
  queryTreeListByTypeForRole,
  queryDepartTreeList,
  queryDepartTreeSync,
  queryIdTree,
  queryParentName,
  searchByKeywords,
  deleteByDepartId,
  deleteLog,
  deleteLogList,
  addDict,
  editDict,
  treeList,
  addDictItem,
  editDictItem,
  doReleaseData,
  doReovkeData,
  getLoginfo,
  getVisitInfo,
  queryUserByDepId,
  checkOnlyUserName,
  duplicateCheck,
  queryTreeListForRole,
  getSystemMenuList,
  getSystemSubmenu,
  getSystemSubmenuBatch,
  loadCategoryData,
  checkRuleByCode,
  queryDepartPermission,
  saveDepartPermission,
  queryTreeListForDeptRole,
  queryDeptRolePermission,
  saveDeptRolePermission,
  queryMyDepartTreeList,
  getUserNoticeInfo,
  getDictItemsFromCache,
  getChargeListApi,
  addReceiptTemplate,
  getBuildingListApi,
  getUnitListApi,
  getRoomListApi,
  downloadOwnerTemplate,
  addCommunityOwner,
  geCommunityOwnertInfoApi,
  auditCommunityOwnerApi,
  geCommunityRuleListApi,
  companyPropertyChargerulesApi,
  getTotalMoneyApi,
  queryByRoomIdApi,
  queryLastDegreesByIdApi,
  callPayMentApi,
  queryDetailByIdApi,
  getHistoryListdApi,
  queryCommunityRepairApi,
  auditCommunityRepairApi,
  dispatchCommunityRepairApi,
  querycommunityComplaintApi,
  auditCommunityComplaintApi,
  auditMoveComplaintApi,
  getPropertyChargruleListApi,
  addCommunityAccountPageApi,
  getDetailReconciliationApi,
  getAccountListByIdApi,
  communityAuditAccountPageApi,
  getCommunityRecordListApi,
  communitySubCompanyApi,
  freezeOrPropertyApi,
  setOwnerLabelApi,
  editOwnerLabelApi,
  setCommunityOwnerLabelApi,
  geQueryByOwnerIdApi,
  geCommunityDeleteApi
}



